class Person {
  var phone: Option[Long] = None
}

abstract class Customer {
  def contractPhone: Option[Long]
}

final class CompanyCustomer extends Customer {
  var representationPerson: Option[Person] = None

  def contractPhone: Option[Long] = {
    representationPerson match {
      case Some(person) => person.phone
      case None => None
    }
  }
}

final class PersonCustomer extends Customer {
  var phone: Option[Long] = None

  def contractPhone: Option[Long] = phone
}
