import scala.xml.Elem

class Book(val name: String, val author: String) {
  override def equals(o: Any): Boolean = {
    o match {
      case b: Book => b.name == name && b.author == author
      case _ => false
    }
  }

  override def hashCode(): Int = {
    name.hashCode + author.hashCode
  }

  override def toString(): String = {
    "Book[name=" + name + ", author=" + author + "]"
  }
}

object Book {
  def create(xml: Elem): Book = {
    new Book(
      (xml \ "name").text,
      (xml \ "author").text
    )
  }

  def apply(name: String, author: String) = {
    new Book(name, author)
  }

  def unapply(xml: Elem): Option[Book] = {
    if (xml.label == "book") Some(create(xml))
    else None
  }
}
